function [w,mapeo]=dsolm(arg1,arg2)
% dsolm: direct class separability optimization linear mapping (DSOLM)
	global n
	global C

    x=arg1;
    
	% cálculo de vector w en 2D para patróns z non vistos durante o cálculo da proxección
    if 1==nargout()
        mapeo=arg2;x=bsxfun(@minus,x,mapeo.med);
        w=x*mapeo.A;return
    end
	
    cl=arg2;np=size(x,1);
    mapeo.med=mean(x);x=bsxfun(@minus,x,mapeo.med);
	X=zeros(n);alfa=-ones(1,np);sdx=zeros(n);
    for c=1:C
        ind=find(cl==c);alfa(:)=-1;alfa(ind)=1;
        for j=1:np
            sdx(:)=0;xj=x(j,:);
            for i=ind
                dx=x(i,:)-xj;sdx=sdx+dx'*dx;
            end
            X=X+alfa(j)*sdx;
        end
    end
    [V,L]=eig(X);
    L(~isfinite(L))=0;L(imag(L)~=0)=0;
    [~,ind]=sort(abs(diag(L)),'descend');
    A=V(:,ind(1:2));w=x*A;mapeo.A=A;
end
