function [w,mapeo]=cdolm(arg1,arg2)
% cdolm: class mean distance optimization linear mapping (CDOLM)
	global n
	global C
	
    x=arg1;
    
	% cálculo de vector w en 2D para patróns z non vistos durante o cálculo da proxección
	if 1==nargout()
        mapeo=arg2;
        x=bsxfun(@minus,x,mean(x));
        w=x*mapeo.A;return
	end
	
	cl=arg2;x=bsxfun(@minus,x,mean(x));  % resta as medias
	m=zeros(C,n);
    for i=1:C
        m(i,:)=mean(x(cl==i,:));
    end
    % cov(m) é igual á matriz B_CD agás un factor constante
    X=cov(m);[V,L]=eig(X);
    [~,ind]=sort(abs(diag(L)),'descend');
    A=V(:,ind(1:2));w=x*A;mapeo.A=A;
end