clear all

problema=textread('lista_problemas.txt','%s');nprobl=length(problema);
prox='CDOLM';

kappa=zeros(1,nprobl);
for j=1:nprobl
	nf=sprintf('../resultados/%s/%s/kappa.dat', problema{j},prox);
	if exist(nf,'file')
		kappa(j)=load(nf);
	else
		kappa(j)=nan;
	end
	fprintf('%s: %6.2f%%\n',problema{j},kappa(j));
end

printf('kappa_med(%s)=%f\n',prox,mean(kappa));

