function [w,mapeo]=pkda(arg1,arg2,arg3)
% pkda: polynomial kernel discriminant analysis
	global C

    x=arg1;D=arg2;
    np=size(x,1);fct=factorial(1:D);
    
    % cálculo de vector w en 2D para patróns x non vistos durante o cálculo da proxección
    if 1==nargout()
        mapeo=arg3;x=bsxfun(@minus,x,mapeo.media);
        tz=x;z=tz; % mapeo polinómico (so termos puros)
        for d=2:D
             z=[z tz.^d/fct(d)];
        end
        w=z*mapeo.A;return
    end
    
    cl=arg3;
    mapeo.media=mean(x);
    x=bsxfun(@minus,x,mapeo.media);

    tz=x;z=tz; % mapeo polinómico (so termos puros)
    for d=2:D
        z=[z tz.^d/fct(d)];
    end
        
    p=size(z,2);np1=np-1;St=cov(z);Sw=zeros(p);
    for i=1:C
        zi=z(cl==i,:);Sw=Sw+size(zi,1)*cov(zi)/np1;
    end
    Sw(~isfinite(Sw))=0;Sw=Sw+eye(p);
    St(~isfinite(St))=0;Sb=St-Sw;
    [V,L]=eig(Sb,Sw);t=diag(L)';
    t(~isfinite(t))=-inf;t(imag(t)~=0)=-inf;
    [~,ind]=sort(t,'descend'); % non usar abs(diag(L))
    A=V(:,ind(1:2));w=z*A;mapeo.A=A;
end

