function [w,mapeo]=qkda(arg1,arg2)
% csoqm: class scatter optimization quadratic mapping (CSOQM)
	global n
	global C
    
    x=arg1;np=size(x,1);
    p=n*(n+1)/2;ncol=n+p;
    
    % cálculo de vector w en 2D para patróns x non vistos durante o cálculo da proxección
    if 1==nargout()
        mapeo=arg2;ind=mapeo.ind;
        x=bsxfun(@minus,x,mapeo.media);
        z=zeros(np,ncol);z(:,1:n)=x;  % mapeo cadrático        
        for i=1:np
            t=x(i,:);u=t'*t;z(i,n+1:n+p)=u(ind);
        end
        w=z*mapeo.A;return
    end
    
    cl=arg2;
    mapeo.media=mean(x);x=bsxfun(@minus,x,mapeo.media);
    k=1;ind=zeros(1,p);
    for i=1:n
        for j=i:n
            ind(k)=(i-1)*n+j;k=k+1;
        end
    end
    mapeo.ind=ind;z=zeros(np,ncol);z(:,1:n)=x;  % mapeo cadrático
    for i=1:np
        t=x(i,:);u=t'*t;z(i,n+1:n+p)=u(ind);
    end
    St=cov(z);Sw=zeros(ncol);np1=np-1;
    for i=1:C
        zi=z(cl==i,:);t=size(zi,1)/np1;Sw=Sw+t*cov(zi);
    end
    St(~isfinite(St))=0;Sw(~isfinite(Sw))=0;
    
    Sw=Sw+eye(ncol);Sb=St-Sw;

    [V,L]=eig(Sb,Sw);
    
    L(~isfinite(L))=0;L(imag(L)~=0)=0;
    [~,ind]=sort(diag(L),'descend');  % non usar abs(diag(L))

    A=V(:,ind(1:2));w=z*A;mapeo.A=A;
end
