function [w,A]=tolm(arg1,arg2)
% tolm: Thornton index optimization linear mapping (TOLM)
	global n
	
    x=arg1;
    
	% cálculo de vector w en 2D para patróns z non vistos durante o cálculo da proxección
	if 1==nargout()
        x=bsxfun(@minus,x,mean(x));
        A=arg2;w=x*A;return
	end
	
	cl=arg2;x=bsxfun(@minus,x,mean(x));
    d=dist2(x,x);[~,nn]=sort(d);
    j=nn(2,:);b=find(cl~=cl(j));
    X=zeros(n);    
    for i=b
        k=j(i);dz=x(i,:)-x(k,:);X=X+dz'*dz;
    end
    [V,L]=eig(X);
    [~,ind]=sort(abs(diag(L)),'descend');
    A=V(:,ind(1:2));w=x*A;
end