function xlabel_inclin(etiq,inclin,ymin,ymax,fontsize)
	n=length(etiq);Xt = 1:n; Xl = [1 n];
	set(gca,'XTick',Xt,'XLim',Xl);

% 	if exist('ymin','var') && exist('ymax','var')
% 		axis([1, n, ymin, ymax])  %isto da erro na gráfica do tempo: memory exhausted
%     end
%     
%     if ~exist('fontsize','var')
%         fontsize=10;
%     end
	
    axis([1 n ymin ymax])
	ax = axis; % Current axis limits
	axis(axis); % Set the axis limit modes (e.g. XLimMode) to manual
	Yl = ax(3:4); % Y-axis limits
	t = text(Xt,Yl(1)*ones(1,length(Xt)), etiq);
	
	set(t,'FontSize',fontsize,'fontname', 'Helvetica','HorizontalAlignment','right','VerticalAlignment','top', 'Rotation',inclin);


	set(gca,'XTickLabel',{' '})

	for i = 1:length(t)
		ext(i,:) = get(t(i),'Extent');
	end

	% Determine the lowest point. The X-label will be
	% placed so that the top is aligned with this point.
	LowYPoint = min(ext(:,2));

	% Place the axis label at this point
	XMidPoint = Xl(1)+abs(diff(Xl))/2;
	tl = text(XMidPoint,LowYPoint,'', 'VerticalAlignment','top', 'HorizontalAlignment','center');
end